#pragma once

#include "Layout.h"
#include "Panel.h"
#include "ScriptletContainerFactory.h"
#include "NWindowTimer.h"

namespace tipuio
{
	class NPCOMMONUI_API TipProgressBar : public CNPanel, public INPTimerHandler
	{
	public:
		// Ѵ.
		enum
		{
			TIMER_ID_PROGRESS = WM_USER + 1,
			TIMER_ID_CANCEL = WM_USER + 2,
			TIMER_HOP = 100,
			HOP_STROLL = 15,			
		};
		enum
		{
			//,  0.0 ~ 1.0
			MIN_VALUE = 0,
			MAX_VALUE = 1,
			//    
			STROLL_VALUE = -10,
			//һ
			CANCEL_VALUE = -20,
		};
		DECLARE_COMPONENT_CREATOR(TipProgressBar)
		TipProgressBar(void);
		virtual ~TipProgressBar(void);

		//override
		void OnSize(INT32 nWidth, INT32 nHeight);
		
		//operation
		double GetPos() { return m_Pos; }
		void SetPos(double pos);

		BOOL SetProperty(LPCTSTR property, CComVariant value);
		BOOL GetProperty(LPCTSTR property, CComVariant& value);

	private:
		//range 0.0 ~ 1.0
		double m_Pos;
		CNWindowTimer m_TimerStroll;
		CNWindowTimer m_TimerCancel;
		// ING    ̵ 
		int m_HopIng;

		BOOL CheckUI();
		void ShowThumbPanel(double pos);
		void Layout_Background(int width, int height);
		void Layout_Progress(int width, int height);
		
		void StartStroll();
		void StopStroll();
		void StartCancel();
		void StopCancel();
		BOOL OnTimer(DWORD dwTimerID);
		BOOL OnTimer_Stroll();
		BOOL OnTimer_Cancel();
		void OnTimer_Cancel_Finish();
		void OnTimer_Cancel_Ing();
	};
};